{ geneticke odvozeni pohybu zivocicha - pro Pgm I. }

uses  Crt;
type
   TAkce = (

      akNOP,

      akGO,
      akLeft,
      akRight );

const
   akLast = akRight;


{ Situace: }

type
   TObsah = ( obNIC, obTRAVA, obBROUK );
const
   obLastObsah = obBROUK;
   PocetObsahu = ord( obLastObsah )+1;
{    [volno,trava,brouk] ^ [vlevo,vpravo,pred]  = 3^3 = 27 }

type
   TSituace = 0..PocetObsahu*PocetObsahu*PocetObsahu  -1;

type
   TSmer = 0..3;

const
   Smery: array[ TSmer ] of record
                             dx, dy: integer
                            end
   = ( (dx:-1;dy:0), (dx:0; dy:-1), (dx:1;dy:0), (dx:0;dy:1) );

type
   TGeny = array[ TSituace ] of TAkce;

type
   TCreature = object
      x,y:  integer;
      smer: byte;
      hlad: integer;
      Geny: TGeny;
      Sezrany: boolean;
      Vek: integer;
      procedure Krok;
   end;

const
   MaxPrirodaX = 49;
   MaxPrirodaY = 15;
   MaxVek      = 20;
type
   TPriroda = array[-5..MaxPrirodaX+5,-5..MaxPrirodaY+5] of TObsah;
var
   Priroda: TPriroda;

const
   MaxPopulace =  500;
   InitPopulace = 500;
var
   Creatures: array[1..MaxPopulace] of TCreature;
   xCreatures: integer;


procedure TCreature.Krok;
var  situace: TSituace;
     xx,yy: integer;
     i: integer;
begin { Krok }

   { vyhodnotit situaci: }
   { doleva: }
   with Smery[ (smer+3) mod 4 ] do
   situace := ord( Priroda[ x +dx, y+dy ] );

   { rovne: }
   with Smery[ smer ] do
   begin
{      writeln( PocetObsahu, ' ', situace, ' ', ord(Priroda[ x +dx, y+dy ]) );{}
{     writeln( x+dx,' ',y+dy, ' ',dy );}
   situace := PocetObsahu * situace +ord( Priroda[ x +dx, y+dy ] );
   end;

   { doprava: }
   with Smery[ (smer+1) mod 4 ] do
   situace := PocetObsahu * situace +ord( Priroda[ x +dx, y+dy ] );


   case Geny[ situace ] of

   akNOP: ;

   akGO: with Smery[ smer ] do
         begin
            xx := 1+ (x+dx+MaxPrirodaX -1) mod (MaxPrirodaX);
            yy := 1+ (y+dy+MaxPrirodaY -1) mod (MaxPrirodaY);
                  ;if yy<0 then
                            writeln;

{            if (xx in [1..MaxPrirodaX-2]) and (yy in [1..MaxPrirodaY-2]) then }
            if Priroda[ xx,yy ] in [obNIC,obBROUK] then
            begin
               if Priroda[ xx,yy ] = obBROUK then
               { nekoho zeru: }
               begin
                  hlad := hlad+1;

                  { znicit brouka na [xx,yy ] }
                  for i:=1 to xCreatures do
                  if (Creatures[ i ].x = xx) and (Creatures[ i ].y = yy) then
                  begin
                     { rozmnozit se, vysledek do [i]: }
                     Creatures[ i ].Sezrany := TRUE;
                     break
                  end
               end;


               Priroda[ xx,yy ] := obBROUK;
               Priroda[ x, y  ] := obNIC;
               x := xx;
               y := yy
            end
               else
                  hlad := hlad-1
            { pokuta za narazeni do zdi? }
         end;

   akLeft:  Smer := (Smer+3) mod 4;
   akRight: Smer := (Smer+1) mod 4;

   else
{      begin
         writeln( Situace,': ',ord( Geny[ situace ] ) );
         RunError( 77 )
      end }
   end;

   Inc( Vek );

   if Vek > MaxVek+ 1000*hlad then
   begin
      Sezrany := TRUE;
      Priroda[ x,y ] := obNIC
   end

end;  { Krok }


var
   i: integer;
   xx,yy: integer;

procedure VypisGeny( Geny: TGeny );
const ZAkce: array[0..3] of char = ( 'x','^','<','>' );
var  sit: integer;
begin
   GotoXY( 1,20 );

   writeln( 'Pred sebou:     NIC    BROUK' );
   writeln( 'Napravo:        N B    N B' );
   write  ( 'Nalevo N:      ' );
   write( ZAkce[ ord( Geny[ 0 ] ) ]:2,ZAkce[ ord( Geny[ 2 ] ) ]:2 );
   write( '   ' );
   write( ZAkce[ ord( Geny[ 6 ] ) ]:2,ZAkce[ ord( Geny[ 8 ] ) ]:2 );
   writeln;

   write  ( 'Nalevo B:      ' );
   write( ZAkce[ ord( Geny[ 18 ] ) ]:2,ZAkce[ ord( Geny[ 20 ] ) ]:2 );
   write( '   ' );
   write( ZAkce[ ord( Geny[ 24 ] ) ]:2,ZAkce[ ord( Geny[ 26 ] ) ]:2 );
end;

var
   krok: longint;
const
   kreslit: boolean = TRUE;
   RosteTrava: boolean = FALSE;

procedure Nakresli;
var  x,y: integer;
const
   Sipka: array[0..3] of char = ( #27,#24,#26,#25 );
   Znak: array[ TObsah ] of char = ( '.','i',' ');
begin
   GotoXY( 1,1 );
   for y:=0 to MaxPrirodaY do
   begin
      if IOResult<>0 then
                       writeln( '!!!' );
      write( '   ' );
      for x := 0 to MaxPrirodaX do  write( Znak[ Priroda[ x,y ] ] );
      writeln
   end;
   writeln;
{   for x:=1 to xCreatures do
      write( Creatures[ x ].hlad:3 ); }

   for i:=1 to xCreatures do
   with Creatures[ i ] do
   begin
      GotoXY( 3+x+1,y+1 );
      TextAttr := hlad+1;
      write( Sipka[ smer ] )
   end;
   TextAttr := 15;
   GotoXY( 1, MaxPrirodaY+2);

   delay( 100 )
end;

const
   prMutace: real = 0.15;

var
   MaxVykon: integer;

procedure Rozmnoz;
var  m1,m2,nova,i: integer;
begin

   { najit dva nejlepsi: }
   m1 := 1;
   m2 := 2;

   if Creatures[ 1 ].hlad < Creatures[ 2 ].hlad then
   begin
      m2 := 1;
      m1 := 2;
   end;

   for i:=3 to xCreatures do
      if Creatures[ i ].hlad > Creatures[ m1 ].hlad then
      begin
         m2 := m1;
         m1 := i
      end
          else
      if Creatures[ i ].hlad > Creatures[ m2 ].hlad then  m2 := i;

   GotoXY( 1,24 );
   writeln( ' ',Creatures[ m1 ].hlad,'---',Creatures[ m2 ].hlad,'  ' );

   VypisGeny( Creatures[ m1 ].Geny );
   write( '      Vykon: ',Creatures[ m1 ].hlad,'   ' );

   if Creatures[ m1 ].hlad > MaxVykon then
   begin
      MaxVykon := Creatures[ m1 ].hlad;
      write( #7 );
      readkey
   end;

   GotoXY( 1, MaxPrirodaY+2);


   { spareni: }

   { kde bude vysledek: }
   if xCreatures < MaxPopulace then
   begin
      Inc( xCreatures );
      nova := xCreatures
   end
      else
   begin
      nova := 1;

      { nejhorsi k nahrazeni: }
      for i:=2 to xCreatures do
         if (i<>m1) and (i<>m2)
            and (Creatures[ i ].hlad < Creatures[ nova ].hlad) then
               nova := i;

      with Creatures[ nova ] do
         Priroda[ x,y ] := obNIC;
   end;



   { vytvoreni vysledku: }
   with Creatures[ nova ] do
   begin

      repeat

         x := random( MaxPrirodaX-2 );
         y := random( MaxPrirodaY-2 );

      until Priroda[ x,y ] in [obNIC,obTRAVA];

      Priroda[ x,y ] := obBROUK;

      Smer := random( 4 );

      for i:=0 to SizeOf( Geny )-1 do
         if random < prMutace then
            Geny[ i ] := TAkce( random( ord( akLast )+1 ) )
                              else
         if random < 0.5 then
            Geny[ i ] := Creatures[ m1 ].Geny[ i ]
                         else
            Geny[ i ] := Creatures[ m2 ].Geny[ i ];

      hlad := 0;{(Creatures[ m1 ].hlad + Creatures[ m2 ].hlad) div 2;}

      Sezrany := FALSE;
      Vek := 0;

   end;

 
   { vynulovat hlad: }
{   if random < 1/10000 then
   for i:=1 to xCreatures do
      Creatures[ i ].hlad := 0;
         { a zase se zavodi nanovo }
end;

begin

   ClrScr;

   { vygenerovat prirodu: }
   FillChar( Priroda, SizeOf( Priroda ), char( obNIC ) );

   for i:=0 to MaxPrirodaX do
   begin
      Priroda[ i, 0           ] := obBROUK;
      Priroda[ i, MaxPrirodaY ] := obBROUK;
         { neni to brouk, ale stena kolem prirody }
   end;

   for i:=0 to MaxPrirodaY do
   begin
      Priroda[ 0,           i ] := obBROUK;
      Priroda[ MaxPrirodaX, i ] := obBROUK;
         { neni to brouk, ale stena kolem prirody }
   end;




   { vytvorit brouky: }
   xCreatures := 0;

   while xCreatures < InitPopulace do
   begin
      Inc( xCreatures );

      with Creatures[ xCreatures ] do
      begin

         repeat

            x := random( MaxPrirodaX );
            y := random( MaxPrirodaY-2 );

         until Priroda[ x,y ] = obNIC;

         Priroda[ x,y ] := obBROUK;

         Smer := random( 4 );

         for i:=0 to SizeOf( Geny )-1 do
            Geny[ i ] := TAkce( random( ord( akLast )+1 ) );

         hlad := 0;
         Sezrany := FALSE;
         Vek := 0

      end;
   end;


   { beh: }
   while TRUE do
   begin

      Inc( Krok );

      { roste trava: }
      if RosteTrava then
      begin

         xx := random( MaxPrirodaX );
         yy := random( MaxPrirodaY );

         if Priroda[ xx,yy ] = obNIC then Priroda[ xx,yy ] := obTRAVA;
      end;

      { mnozeni: }
      if ((Krok mod 100)=0) then
      begin
         Rozmnoz
      end
         else
      if {(random < 0.1) and} (xCreatures < MaxPopulace) {} then
      begin
         Rozmnoz;
         Rozmnoz;
         Rozmnoz;
         Rozmnoz;
         Rozmnoz;
         Rozmnoz;
         Rozmnoz;
         Rozmnoz;
         Rozmnoz;
         Rozmnoz;
         Rozmnoz;
         Rozmnoz;
      end;

      for i:=1 to xCreatures do
         Creatures[i].Krok;

      { vyhodit sezrane: }
      i := 1;
      while i <= xCreatures do
         if Creatures[ i ].Sezrany then
         begin
            move( Creatures[ i+1 ], Creatures[ i ],
                  (xCreatures-i)*SizeOf( Creatures[ i ] ) );
            Dec( xCreatures )
         end
            else Inc( i );


      if Kreslit then  Nakresli;

      write( 'Krok/xCreatures: ',Krok,'/',xCreatures,'   '#13 );

      if keypressed then if ReadKey = #3 then halt
                                         else
      case ReadKey of
      'k': Kreslit := not Kreslit;
      't': RosteTrava := not RosteTrava;
      '+': prMutace := 2*prMutace;
      '-': prMutace := prMutace/2;
      end; { case }

{      repeat until keypressed {}
   end;

end.


