uses  Crt, Graph;

const
   Max      = 255;
   Kodpuz   = 0.15;
   Kpritaz  = 0.15;

   x0  = 320;
   y0  = 200;
   Kx: real  = 50.0;
   Ky: real  = 50.0;

var
   Bod: array[0..Max] of record
       x,y: real;
       Hrany: set of 1..Max
        end;
   N: byte;
   PocetKroku: word;

procedure Krok;
var  i,j,k: byte;
     pomal: longint;
     sx,sy: real;
     dx,dy,vzd: real;
begin
   Inc( PocetKroku );

   { zpomaleni pro 733:
   for pomal:=1 to 200000 do
                        sx := pomal; {}

   for k:=1 to N do {}
   begin
      i := k{1+random(N)};
      { pohnout s i-tym bodem }
      sx:=0; sy:=0; { sily }
      for j:=1 to N+1 do
         if i<>j then
         begin
            dx:=Bod[j].x-Bod[i].x;
            dy:=Bod[j].y-Bod[i].y;
            vzd:=sqrt( dx*dx + dy*dy );
            (***********************************
            sx := sx - Kodpuz/vzd/vzd *dx/vzd;
            sy := sy - Kodpuz/vzd/vzd *dy/vzd;
            ***********************************)
            if j < (N+1) then
            begin
               sx := sx - Kodpuz *dx/vzd;
               sy := sy - Kodpuz *dy/vzd
            end
               else
            begin
               sx := sx + 0.1*Kodpuz *dx/vzd;
               sy := sy + 0.1*Kodpuz *dy/vzd
            end;

            if j in Bod[i].Hrany then
            begin
               sx := sx + Kpritaz*vzd*vzd   *dx/vzd;
               sy := sy + Kpritaz*vzd*vzd   *dy/vzd;
            end
         end;

      Bod[i].x:=Bod[i].x + 0.1*sx;
      Bod[i].y:=Bod[i].y + 0.1*sy
   end
end;

function fx( x: real ): word;
begin
    fx:=x0 + round( Kx * x )
end;

function fy( y: real ): word;
begin
   fy:=y0 + round( Ky * y )
end;

procedure Nakresli;
var  i,j: byte;
begin
   for i:=1 to N do
   with Bod[i] do
   begin
      Circle( fx(x), fy(y), 2 );

      for j:=1 to N do
      if j in Hrany then
         Line( fx(x), fy(y),  fx(Bod[j].x), fy(Bod[j].y) )
   end;

   Line( fx(0)-2,fy(0),fx(0)+2,fy(0) );
   Line( fx(0),fy(0)-2,fx(0),fy(0)+2 );
end;

procedure InitBody;
var  i: byte;
begin
   randomize;
   for i:=1 to Max do
   begin
      Bod[i].x:=random;
      Bod[i].y:=random;
      Bod[i].hrany:=[];
   end;

   Bod[ N+1 ].x:=0;
   Bod[ N+1 ].y:=0
end;

procedure StartGr;
var  d,m: integer;
begin
   detectgraph( d,m );
   initgraph( d,m,'bp' )
end;

var i,j,  sx,sy: byte;
    a,b: byte;
begin
   InitBody;
   randomize;

   (********************************)
   N:=5;
   Bod[3].Hrany:=[1,2,  4,5];
   Bod[2].Hrany:=[1,  3,4,5];
   Bod[4].Hrany:=[1,2,3,  5];
   Bod[1].Hrany:=[  2,3,4,5];
   Bod[5].Hrany:=[1,2,3,4  ];
   (** 1 ******************************
   N:=12;
   Bod[1].Hrany:=[2,4];
   Bod[2].Hrany:=[1,3,5];
   Bod[3].Hrany:=[2,6,10];
   Bod[4].Hrany:=[1,5,7];
   Bod[5].Hrany:=[2,4,6,8];
   Bod[6].Hrany:=[3,5,9,11];
   Bod[7].Hrany:=[4,8];
   Bod[8].Hrany:=[5,7,9];
   Bod[9].Hrany:=[6,8,12];
   Bod[10].Hrany:=[3,11];
   Bod[11].Hrany:=[6,10,12];
   Bod[12].Hrany:=[9,11];
   (********************************
   sx := 8;
   sy := 8;
   Kx := 3.0;
   Ky := 3.0; {}
   N:=sx*sy;
   for i:=0 to sx-1 do
   for j:=0 to sy-1 do
   with Bod[1+ sy*i +j] do
   begin
      Hrany := [];
      if i>0 then
               Hrany := Hrany + [1+ sy*(i-1) +j];
      if i<sx-1 then
               Hrany := Hrany + [1+ sy*(i+1) +j];
      if j>0 then
               Hrany := Hrany + [1+ sy*i +j-1];
      if j<sy-1 then
               Hrany := Hrany + [1+ sy*i +j+1];
   end;

   {
   i := N div 4;

   while i > 0 do
   begin
      sx := 1+random( N );
      sy := 1+random( N );
      if sy in Bod[sx].Hrany then
      if [sy]<>Bod[sx].Hrany then
      begin
         Bod[sx].Hrany := Bod[sx].Hrany - [sy];
         Bod[sy].Hrany := Bod[sy].Hrany - [sx];
         Dec( i )
      end
   end; {}

  (**********************************
   N:=9;
   Bod[1].Hrany:=[2,4];
   Bod[2].Hrany:=[1,3,5];
   Bod[3].Hrany:=[2,6];
   Bod[4].Hrany:=[1,{5,}7];
   Bod[5].Hrany:=[2,{4,}6,8];
   Bod[6].Hrany:=[3,5,9];
   Bod[7].Hrany:=[4,8];
   Bod[8].Hrany:=[5,7,9];
   Bod[9].Hrany:=[6,8];
(*************************************
   N:=8;
   Bod[1].Hrany:=[2,4,5];
   Bod[2].Hrany:=[1,3,6];
   Bod[3].Hrany:=[2,4,7];
   Bod[4].Hrany:=[1,3,8];
   Bod[5].Hrany:=[1];
   Bod[6].Hrany:=[2];
   Bod[7].Hrany:=[3];
   Bod[8].Hrany:=[4];
(*************************************
   N:=8;
   Bod[1].Hrany:=[2,4,3];
   Bod[2].Hrany:=[1,5,6];
   Bod[5].Hrany:=[2,4,7];
   Bod[4].Hrany:=[1,5,8];
   Bod[3].Hrany:=[1,6,8];
   Bod[6].Hrany:=[2,3,7];
   Bod[7].Hrany:=[5,6,8];
   Bod[8].Hrany:=[4,3,7];
(*************************************
   N:=16;
   Bod[1].Hrany:=[2,4,5,9];
   Bod[2].Hrany:=[1,3,6,10];
   Bod[3].Hrany:=[2,4,7,11];
   Bod[4].Hrany:=[1,3,8,12];
   Bod[5].Hrany:=[1,6,8,13];
   Bod[6].Hrany:=[2,5,7,14];
   Bod[7].Hrany:=[3,6,8,15];
   Bod[8].Hrany:=[4,5,7,16];

   Bod[ 9].Hrany:=[1,10,12,13];
   Bod[10].Hrany:=[2, 9,11,14];
   Bod[11].Hrany:=[3,10,12,15];
   Bod[12].Hrany:=[4, 9,11,16];
   Bod[13].Hrany:=[5, 9,14,16];
   Bod[14].Hrany:=[6,10,13,15];
   Bod[15].Hrany:=[7,11,14,16];
   Bod[16].Hrany:=[8,12,13,15];
(*************************************)



   StartGr;
   PocetKroku:=0;
   Nakresli;
   readln;

   repeat
    {  if (PocetKroku mod 100) = 0 then }
      begin
       if (PocetKroku mod 10) = 0 then  {}
         ClearDevice;
         Nakresli;
      end;
      { if keypressen then }
      Krok
   until keypressed and (ReadKey=#27);
   writeln( PocetKroku )

end.