program Broucci;

uses  Crt;

const
   KreslitDrahu: boolean = FALSE;

{  Cl:
     Systemticky prozkoumat vvoj VKON a NEJLEP ALGORITMUS
     brouka v jednoduchm prosted
     v zvislosti na dostupn VELIKOSTI PAMTI.

        = Pklady pedvdn na pednkch geneticky hledaly
          optimln algoritmus bez pamti. Bylo by zajmav vidt,
          jak pome jeden bit, dva bity, ...

     Tenhle przkum by bylo dobr zrove udlat pro vyerpvajc
     spektrum loh podle tchto kriteri:
       - brouek sm vs. konkurenn prosted
         (to bude asi jin algoritmus a tak bude jin algoritmus
          proti "chytrm" a "hloupm" konkurentm)
       - potrava definitivn spotebovvan vs. dorst
       - potrava nepohybliv trva vs. pohybliv ivoichov
         (a zase jet dal lenn podle algoritmu pohyblivosti
           - nhodn
           - pohyb nezvisl na broukovi
           - pohyb zvisl na broukovi (vid brouka, tak utk) )
       - potrava pasivn (trva, ni ivoich) vs. nebezpen
         (jin brouek)
       - nepejiteln, ppadn ubliujc pekky - ano, ne
         (asi by stailo ANO)
       - pokladat si znacky?? (jeden druh vs. vice druhu?)
         = asi jako instrukce KROK = polozit znacku a udelat krok
       - ? dal?

   Problm vyhodnocovn:
     Pvodn brouci se v jednom bluditi pohybovali, tm vyhodnocovali
     (vichni najednou) a zrove rodili a zanikali a tm probhal vbr.
     Takhle asi nepjde vyhodnocovat brouky rzn inteligence - najt algoritmus
     ano, ale ne mit, potat kvalitu, protoe mezi stejn chytrmi, kde
     body zskvaj sernm jinho bude prmrn kvalita stejn.

     Kdyby v prosted byli zrove brouci rzn inteligence, problm je zase v tom,
     e geometrickou adou, i kdyby jedni byli jen 51% proti 49%, za chvli budou jen
     prv.
     => Proto by bylo lep nezvisl vyhodnocovn kadho jedince v umlm
     prosted jen pro nj. To bude nronj na vpoet, pomalej.  


   Poznmka:
      S jednm stavem by mli teba najt algoritmus cesty podle zdi...
      Co algoritmus na vyrn cel plochy? Kolik stav?
}


{ hriste: }
   { pneumatika rozmeru MAXX x MAXY }
const
   MAXX = 20;
   MAXY = 13{20};

type
   TPrvek = (nic, jidlo, zed);
   TPool = array[0..MAXX-1, 0..MAXY-1] of TPrvek;
const
   znPrvek: array[TPrvek] of char = ( ' ', '*', 'M' );

{ algoritmus: }
   { vidi doleva, doprava, pred sebe a zna stav }
const
   MaxStav = 15; { 4 bity, ale moc na tom nesejde }
   PocetStavu: integer = 1{3{4{3{1{2{5{2{1{5{3{1{2{1{5{1{2{1{5{2{1};
   pJidlo: real = 0.4;
   pZed: real = 0.2{0.2{0.1{0.2{ 0.0{0.1{0.2};
   pNic: real = 777.77   {1-pZed-pJidlo{0.4{ 0.8{0.2{0.4};

   prMutace: real = 0.2{05};


const
   MaxPopulace = 10{5};
const
   PocetTestu = 10;

type
   TStav = 0..MaxStav;
   TAkce = ( akNic, akDoleva, akDoprava, akKrok );
        { NIC nema smysl v prostredi bez souperu a bez rostouci potravy urcite }
const
   akLastAkce = akKrok;
   PocetAkci = ord(akLastakce)+1;
{   znAkce: array[TAkce] of char = ( '.', #27, #26, #24 ); {}
   znAkce: array[TAkce] of char = ( '.', '<', '>', '^' );
type
   TAkceStav = 0..(MaxStav * ord(akLastAkce));
   TAlgoritmus = array[ TStav, TPrvek, TPrvek, TPrvek ] of TAkceStav;

procedure InitPool( var P: TPool; var PocetJidla: integer );
const
   PocetNeceho = MAXX*MAXY div 2;
var  x,y: integer;
     r: real;
begin

   (***************
   { vyplnit jidlem: }
   FillChar( P, SizeOf( P ), ord( jidlo ) );

   { vyprazdnit: }
   FillChar( P, SizeOf( P ), ord( nic ) );
   ******************************)

   PocetJidla := 0;

   { nahodne jidlo a zdi: }
   for x:=0 to MAXX-1 do
   for y:=0 to MAXY-1 do
   begin
      r := random;
      if r < pZed then P[x,y] := zed
                  else
      if r < pZed+pNic then P[x,y] := nic
                       else
      if (P[x,y] <> jidlo)
         and
         (x>0) and (y>0) { 24.9.2004 - abych nedaval na vychozi pozici }
       then
      begin
         P[x,y] := jidlo;
         Inc( PocetJidla )
      end
   end;

end;

procedure DrawPool( var P: TPool );
var  x,y: integer;
begin
   for y:=0 to MAXY-1 do
   begin
      writeln;
      for x:=0 to MAXX-1 do
         write( znPrvek[ P[x,y] ] )
   end
end;

{======================================================================}
type
   TSmer = ( smNahoru, smDoprava, smDolu, smDoleva );
const
   znSmer: array[ TSmer ] of char = ('',#26,'','' );

procedure InitAlgoritmus( var Alg: TAlgoritmus );
var  stav: TStav;
     pL, psmer, pP: TPrvek;
     st: integer;
begin
   for stav := 0 to PocetStavu-1 do
   for pL   := nic to zed do
   for psmer:= nic to zed do
   for pP   := nic to zed do
   begin
      st := random( PocetStavu );
      Alg[ stav, pL, psmer, pP ] := 1+random( PocetAkci-1 )
                                       { nedovolim akNic }
                                    + st*PocetAkci
   end
end;

procedure TiskAlgoritmu( var Alg: TAlgoritmus );
var stav: byte;
    pL, psmer, pP: TPrvek;
    AkSt: TAkceStav;
    i: integer;
const
   x0 = 25;
   y0 = 5;
begin
   GotoXY( x0, y0-2 );
   writeln( '             pred: .      *       M' );
   for stav := 0 to PocetStavu-1 do
   begin
      GotoXY( x0, y0+4*stav-1 );
      writeln( 'stav: ',stav );
      for i:=1 to 3 do
      for pP   := nic to zed do
      begin
         gotoXY( x0-2+10*i+3*ord(pP), y0+4*stav-1 );
         write( znPrvek[ pP ]:3 );
      end;

      for pL   := nic to zed do
      begin
         GotoXY( x0, y0+4*stav+ord( pL ) );
         write( 'vlevo: ',znPrvek[ pL ] );
         for psmer:= nic to zed do
         for pP   := nic to zed do
         begin
            GotoXY( x0+10+10*ord(psmer)+3*ord(pP), y0+4*stav+ord( pL ) );

            AkSt := Alg[ stav, pL, psmer, pP ];
            write( znAkce[ TAkce( AkSt mod PocetAkci ) ],
                   AkSt div PocetAkci );
         end
      end
   end
end;
{======================================================================}

const
   dx: array[TSmer] of shortint = (  0, 1, 0, MAXX-1 );
   dy: array[TSmer] of shortint = (  MAXY-1, 0, 1, 0 );

{======================================================================}
type
   THodnota = real;

const
   MaxHist = MAXX*MAXY*4*5*1; { Smery*MaxStavu }
                { melo by byt *2, ale nevejde se }
var
   Hist: array[1..MaxHist] of
      record
         ax,ay,astav: byte;
         asmer: TSmer
      end;
      { slouzi k hlidani zacykleni }
   iHist: 0..MaxHist;

function Vykon( var Alg: TAlgoritmus; {var} Pool: TPool; PocetKroku: integer;
                                                         PocetJidla: integer )
         : THodnota;
var  x,y: integer;
     smer,  smL, smP: TSmer;
     Stav: TStav;
     korist, zraneni: integer;
     AkSt: TAkceStav;
     AK: TAkce;
     nx, ny: integer;

     ax, ay, bx, by, cx, cy: integer;
     pL,psm,pP: TPrvek;

begin
   {---------------------}
   x := 0;
   y := 0;
   smer := smDoprava;
   Stav := 0;
   korist := 0;
   zraneni := 0;
   {---------------------}

{   KreslitDrahu := TRUE; { *** pro odladeni Hist }

   if KreslitDrahu then
   begin
      ClrScr;
      DrawPool( Pool );
      TiskAlgoritmu( Alg );
   end;

   iHist := 0;
   while TRUE do
   begin

      { ulozit aktualni stav: }
      Inc( iHist );
      with Hist[ iHist ] do
      begin
         ax := x;
         ay := y;
         astav := stav;
         asmer := smer
      end;

      { test zacykleni: }
      if iHist > 1 then
      with Hist[ iHist div 2 ] do
      begin
         if (ax=x) and (ay=y) and (astav=stav) and (asmer=smer) then
            { jsem zacyklen }
         begin
{            writeln( 'CYKLUS ', PocetKroku );
            readln; {}
            break
         end
      end;

      if KreslitDrahu then
      begin
         GoToXY( x+1, y+2 );  { DrawPool zacina writeln }
         TextAttr := 14-stav;
         write( znSmer[ smer ] );
         TextAttr := 7;

         GoToXY( 1,1 );
         write( korist,'/',PocetJidla );
         if ReadKey=#27 then
                           exit
      end;

      { urcit akci podle algoritmu: }
      smL := TSmer( (ord( smer )+3) mod 4 );
      smP := TSmer( (ord( smer )+1) mod 4 );

      (**************************************
      ax := (x+dx[smL] ) mod MAXX;
      ay := (y+dy[smL] ) mod MAXY;
      bx := (x+dx[smer] ) mod MAXX;
      by := (y+dy[smer] ) mod MAXY;
      cx := (x+dx[smP] ) mod MAXX;
      cy := (y+dy[smP] ) mod MAXY;

      writeln( ax,ay,' ',bx,by, ' ', cx,cy );

      pL  := Pool[ ax,ay ];
      psm := Pool[ bx,by ];
      pP  := Pool[ cx,cy ];
      writeln( znPrvek[ pL ],znPrvek[ psm ],znPrvek[ pP ] );
      **********************************)

      AkSt := Alg[ Stav,
                   Pool[ (x+dx[smL] ) mod MAXX, (y+dy[smL] ) mod MAXY ],
                   Pool[ (x+dx[smer]) mod MAXX, (y+dy[smer]) mod MAXY ],
                   Pool[ (x+dx[smP] ) mod MAXX, (y+dy[smP] ) mod MAXY ]
                 ];

      Stav := AkSt div PocetAkci;
         { omezeni skutecnym povolenym octem stavu (MaxStav je pro deklarace) }

      { provest akci: }
      case TAkce( AkSt mod PocetAkci ) of
      akNic: ;
      akDoleva:   smer := TSmer( (ord( smer )+3) mod 4 );
      akDoprava:  smer := TSmer( (ord( smer )+1) mod 4 );
      akKrok:     begin
                     nx := (x+dx[smer]) mod MAXX;
                     ny := (y+dy[smer]) mod MAXY;

                     case Pool[ nx,ny ] of
                     jidlo: begin
                               Inc( korist );
                               iHist := 0;
                               Pool[ nx,ny ] := nic;
                               x := nx;
                               y := ny;

                               if korist=pocetjidla then
                                                       break;
                               { uz neni co sbirat - nema smysl pokracovat }
                            end;
                     nic:   begin
                               x := nx;
                               y := ny
                            end;
                     zed:   begin
                               Inc( zraneni );
                            end;
                     end { case }
                  end;
      end; { case }

      Dec( PocetKroku )

   end; { while }

   { nejak urcit vysledek z koristi a zraneni: }
       { zraneni asi neni treba, protoze kdyz chce udelat krok do zdi
         a neudela ho, tak uz nezmeni... (ale jo, muze zmenit stav...)) - spatna uvaha! }

{   write( korist/PocetJidla:5:2 ); {}
   Vykon := korist/PocetJidla; {- 10*zraneni{}
               { zraneni prece jen ignorovat
                 - stat pred zdi se nevyplati i kdyz za to nebude zraneni }
   if KreslitDrahu then
   begin
      { zopakovany tisk, aby nezustavala korist o 1 mensi: }
      GoToXY( 1,1 );
      write( korist,'/',PocetJidla );

      gotoXY( 10,1 );
      write( 'Sebrano: ',100*korist/Pocetjidla:5:2,'%     ' );
      repeat until ReadKey=#13
         { abych poznal, ze konec }
   end

   ; Vykon := korist
      { uprava, abych snadneji poznal, kolik hvezdicek sebere
        = 24.9.2004 kvuli hledani broucka "all-3" }
end;

var
   TestPool: array[1..PocetTestu] of TPool;
   PocetJidla: array[1..PocetTestu] of integer;

function Hodnota( var Alg: TAlgoritmus ): THodnota;
var Pool: TPool;
    h,hmin, hsum: THodnota;
    pokusy: integer;
begin
   { InitPool( Pool ); {}
   hmin := maxint;
   h := 0;
   hsum := 0;
   for pokusy := 1 to PocetTestu do
   begin
      h := Vykon( Alg, TestPool[ pokusy ], 0{MaxPocetKroku},
                       Pocetjidla[ pokusy ] );
      hsum := hsum + h;
      if h < hmin then
                     hmin := h {}
   end;

      { vybiram prumerny //nejhorsi// vysledek }

   KreslitDrahu := FALSE;
   Hodnota := (hsum +5*hmin)/(PocetTestu+5{}) {+random/10{}
                             { nahodne posunuti, aby nestagnovalo na jednom }
      { soucet, ale vyplati se zvysovat nejhorsi pripad }
   ; Hodnota := hsum
      { 24.9.2004 uprava kvuli snadnejsimu poznani "all-3" }
end;

{ === geneticky vyber: =========================================== }

var
   Populace, NewPopulace: array[0..MaxPopulace] of
             record
                alg: TAlgoritmus;
                x:   THodnota
             end;

procedure SetridPopulaci;
var  i,j: integer;
begin
   i := 1;
   while i<MaxPopulace do
      if Populace[i].x >= Populace[i+1].x then { OK }
                                            Inc( i )
                                         else
      begin
         { vymenit a zmensit index: }
         Populace[0] := Populace[i];
         Populace[i] := Populace[i+1];
         Populace[i+1] := Populace[0];

         if i>1 then Dec(i)
            { jinak zustane }
      end

end;

procedure VytvorPopulaci;
var  i: integer;
begin
   for i:=1 to MaxPopulace do
   with Populace[i] do
   begin
      InitAlgoritmus( alg );
      x := Hodnota( alg )
   end;

   SetridPopulaci
end;

var
   krok, krokPosledniZmeny: longint;
   LastBest: real;
   initRandSeed: longint;

procedure GenetickyKrok;
{ uz jsou nastaveny vahy a setrideno }
{ bude se krizit P[1] a nahodny partner,
  vysledek se pise do P[MaxPopulace] a pak probubla via SetridPopulaci }
var  stav: TStav;
     pL, psmer, pP: TPrvek;
     st: integer;
     R1,R2: TAlgoritmus;
     Ri, i: integer;
     KrokuOdZmeny: longint;
begin
   Inc( krok );
{   if krok mod 1000 = 0 then
                          write( krok,#13 ); {}

   prMutace := 1/3-(krok div 1{} mod (1*1000))/(1*3000);  { 0-0.33 } {}
   prMutace := prMutace/10;

{   Inc( KrokuOdZmeny );
   if KrokuOdZmeny mod 1000 = 0 then
       prMutace := prMutace * 2; {}

   R1 := Populace[1].alg;
   Ri := 1+random(MaxPopulace);
   R2 := Populace[ Ri ].alg;
      { predpokladam, ze tahle kopie se zaplati usetrenim
        staleho vybirani podle indexu Populace[i] }

   with Populace[ MaxPopulace ] do
   begin
      for stav := 0 to PocetStavu-1 do
      for pL   := nic to zed do
      for psmer:= nic to zed do
      for pP   := nic to zed do
      {----------------------------------------}
         if random < prMutace then
         begin
            st := random( PocetStavu );
            Alg[ stav, pL, psmer, pP ] := 1+random( PocetAkci-1 )
                                             { nedovolim akNic }
                                          + st*PocetAkci
         end
            else
         { podle jednoho z rodicu: }
         if random < 0.5 then
              Alg[ stav, pL, psmer, pP ] := R1[ stav, pL, psmer, pP ]
                         else
              Alg[ stav, pL, psmer, pP ] := R2[ stav, pL, psmer, pP ];
      {----------------------------------------}

      { uz po cyklech: }
      x := Hodnota( alg )
   end;

   SetridPopulaci;

   if Populace[1].x > LastBest then
   begin
{      KrokuOdZmeny := 0;
      prMutace := 0.001; {}
      Lastbest := Populace[1].x;
      krokPosledniZmeny := krok;
      write( krok:5,': ' );
      for i:=1 to MaxPopulace do
         write( Populace[i].x:7:0 );
      write( #13 )
      ;writeln
   end
end;

procedure GenetickyKrok2;
{ vytvorit celou novou populaci }
{ uz jsou nastaveny vahy a setrideno }
var  stav: TStav;
     pL, psmer, pP: TPrvek;
     st: integer;
     R1,R2: TAlgoritmus;
     Ri, i: integer;
     KrokuOdZmeny: longint;
     {-----------}
     a,b, np, prevzati, iR1: integer;
begin
   { prevzato z GenetickyKrok: }
   Inc( krok );
{   if krok mod 1000 = 0 then
                          write( krok,#13 ); {}

   prMutace := 1/3-(krok div 1{} mod (1*1000))/(1*3000);  { 0-0.33 } {}
   prMutace := prMutace/10;

{   Inc( KrokuOdZmeny );
   if KrokuOdZmeny mod 1000 = 0 then
       prMutace := prMutace * 2; {}
   {----------------------------------}

   { naplnit novou populaci: }
   NewPopulace[1] := Populace[1];
     { nejlepsi = elita }

   np := 1;

   { do dvou tretin naplnim vybranymi cleny minule generace }
   for np := 2 to MaxPopulace div 2 do
   begin
      a := 1+random(MaxPopulace);
      b := 1+random(MaxPopulace);
         { dva nahodne vybrani }

      if b < a then
                 a := b;
      { z nich vyberu toho s lepsim hodnocenim,
        ale (Populace je setridena) to znamena toho s mensim cislem }
      NewPopulace[np] := Populace[a]
   end;

   { ... a zbytek budou potomci: }
   iR1 := 0;
   prevzati := np;
   for np := np to MaxPopulace do
   begin
      Inc( iR1 );
      R1 := Populace[1].alg;
      Ri := 1+random(prevzati); { ze vsech dosavadnich }
      R2 := Populace[ Ri ].alg;

      with Populace[ np ] do
      begin
         for stav := 0 to PocetStavu-1 do
         for pL   := nic to zed do
         for psmer:= nic to zed do
         for pP   := nic to zed do
         {----------------------------------------}
            if random < prMutace then
            begin
               st := random( PocetStavu );
               Alg[ stav, pL, psmer, pP ] := 1+random( PocetAkci-1 )
                                                { nedovolim akNic }
                                             + st*PocetAkci
            end
               else
            { podle jednoho z rodicu: }
            if random < 0.5 then
                 Alg[ stav, pL, psmer, pP ] := R1[ stav, pL, psmer, pP ]
                            else
                 Alg[ stav, pL, psmer, pP ] := R2[ stav, pL, psmer, pP ];
         {----------------------------------------}

         { uz po cyklech: }
         x := Hodnota( alg )
      end
   end; { for }

   SetridPopulaci;

   { zase prevzato; }
   if Populace[1].x > LastBest then
   begin
{      KrokuOdZmeny := 0;
      prMutace := 0.001; {}
      Lastbest := Populace[1].x;
      write( ' ',krok:5,': ' );
      for i:=1 to MaxPopulace do
         write( Populace[i].x:7:0 );
      write( #13 )
      {;writeln {}
   end
end;

const
   PocetOpak = 3000;
   {MaxPocetKroku: integer = 2000;  { pocet kroku na vyhodnoceni algoritmu }
   MaxKrok = 3000{500{300{10000}; { max pocet genetickych kroku }

var
   NejlepsiAlgoritmus: TAlgoritmus;

function Vypocet: THodnota;
var opak,i: integer;
    BestLastBest: THodnota;
begin


   BestLastBest := 0;
   for opak := 1 to PocetOpak do {}
   {while TRUE do{}
   begin
      writeln( '----- pokus: ',opak,' -------' );

      VytvorPopulaci;

      { vypocet: }
      LastBest := 0.00;
      krok := 0;
      while {TRUE{}krok-krokPosledniZmeny< MaxKrok{} do
      (* while {TRUE{}krok < MaxKrok{} do *)
      begin
         { GenetickyKrok {}
         GenetickyKrok2 {}
         { patch na vylouceni pomalych: }
{         ;if (krok=3000) and (LastBest<0.90) then break; {}
{         ;if (krok=500) and (LastBest<0.80) then break; {}
{         ;if (krok=200) and (LastBest<0.50) then break; {}
{         ;if (krok=500) and (LastBest<0.70) then break; {}
{         ;if (krok=200) and (LastBest<0.450) then break; {}
         ;if (krok=3000) and (LastBest<900) then break; {}

         ; if keypressed then
         case ReadKey of
         'k': begin
                 KreslitDrahu := TRUE;
                 if Hodnota( Populace[1].alg ) >0 then;

                 write( #7 );
                 readln
              end;
         'K': begin
                 write( BestLastBest:7:0 ); readln;
                 KreslitDrahu := TRUE;
                 if Hodnota( NejlepsiAlgoritmus ) >0 then;

                 write( #7 );
                 readln
              end;
         'm': begin
                 prMutace := prMutace /2;
                 gotoXY( 30,10 );
                 write( 'prMutace=',prMutace:10:6,'   ' )
              end;
         'M': begin
                 prMutace := prMutace *2;
                 gotoXY( 30,10 );
                 write( 'prMutace=',prMutace:10:6,'    ' )
              end;
         'r': begin
                 writeln( 'RandSeed = ', RandSeed );
              end;

         #27: halt(1);
         #3:
              writeln;
         end; { case }
      end;

      if Lastbest > BestLastBest then
      begin
         BestLastBest := LastBest;
         NejlepsiAlgoritmus := Populace[1].alg
      end;
      writeln
   end;

   LastBest := BestLastBest;
   Vypocet := BestLastBest

end;

var
   i: integer;
   pokus: integer;
const
   pp: array[1..10,1..2] of real
       = ( { jidlo zed  {}
            ( 0.1, 0.0 ),
            ( 0.5, 0.0 ),
            ( 1.0, 0.0 ),

            ( 0.1, 0.2 ),
            ( 0.5, 0.2 ),
            ( 0.8, 0.2 ),

            ( 0.1, 0.35 ),
            ( 0.5, 0.35 ),
            ( 0.65,0.35 ),

            ( 0.6, 0.4 ) );
var
   CelkemJidla: integer;
begin
   Textattr := 7;
   CelkemJidla := 0;
   for i:=1 to PocetTestu do
   begin
      pJidlo := pp[i,1];
      pZed   := pp[i,2];
      pNic   := 1-pJidlo-pZed;

      InitPool( TestPool[i], PocetJidla[i] );
      Inc( CelkemJidla, PocetJidla[i] );
   end;
   writeln;
   writeln( 'CelkemJidla = ',CelkemJidla );
   writeln;

   randomize; {}
   initRandSeed := RandSeed;


{   PocetStavu := 3{2{1{5{1{2{5{2{3{2{1};

   { Vypocet; {}
   writeln( '>>>',Vypocet:7:0,'<<<' );

   { tady znam LastBest }


   writeln( 'konec' );
   readln;

   { nakreslit nejlepsi algoritmus: }
   KreslitDrahu := TRUE;
   if Hodnota( NejlepsiAlgoritmus ) >0 then;

   writeln( LastBest )


end.






var  P: TPool;
     Alg: TAlgoritmus;
begin
   InitPool( P );
   DrawPool( P );
   readln;
   repeat
      InitAlgoritmus( Alg );
      InitPool( P );
      write( Vykon( Alg, P, 10 ),'    ',#13 );
   until FALSE
end.

GotoXY
====================================
# Hodnota - ne presne prumer, zohlednit nejhorsi pripady
# Hodnota - negenerovat vzdy nahodne Pool, ale mit treba 5-10 stalych,
            na kterych se testuje
# vypisovani nejlepsiho algoritmu
# prMutace - nastavovani automaticky?
# ? proc se vysledek moc nelepsi s pridavani stavu? Je zhruba stejny...
# zdi - nahodne balvany je neco jineho nez ZDI. Zkusit?
# prZdi, prNic...
