{ 20.5.2010 }
{ demonstrace genetickeho algoritmu }
uses  Crt;

const
   mX = 8;
   my = 8;
   PocetPrvku = 10;
   cMutace = 0.03;
type
   TPrvek = array[1..mX,1..mY] of boolean;

var
   Prvky: array[1..PocetPrvku] of TPrvek;
   Hodnota: array[1..PocetPrvku] of integer;

   Vzor:  TPrvek;

procedure InitPrvky;
var  i,j,k: byte;
begin
   for i:=1 to PocetPrvku do
   for j:=1 to mX do
   for k:=1 to mY do
      Prvky[i][j,k] := random > 0.5
end;


procedure InitVzor;
var  i,j: byte;
     s: string;
begin
   ClrScr;
   writeln( 'Zadej vzor: ' );
   for j:=1 to mY do
   begin
      readln( s );
      for i:=1 to mX do
         Vzor[i,j] := UpCase(s[i]) = 'X'
   end
end;

var
   MAX1, MAX2, MIN: byte;

procedure TiskPrvky;
var i,j,k: byte;
begin
   ClrScr;
   for i:=1 to PocetPrvku do
   begin
      if (i=MAX1) then  TextColor( 14 )
                  else
      if (i=MAX2) then  TextColor( 10 )
                  else
      if (i=MIN ) then  TextColor( 13 )
                  else  TextColor( 15 );

      if MAX1 <> 255 then
      { tisk hodnoty: }
      begin
         if i <= 5 then  gotoXY( 8+12*(i-1), 10 )
                   else  gotoXY( 8+12*(i-6), 21 );

         write( 1.0*Hodnota[i]:5:2 )
      end;


      for k:=1 to mY do
      begin
         if i <= 5 then  gotoXY( 5+12*(i-1),  1+k )
                   else  gotoXY( 5+12*(i-6), 12+k );

         for j:=1 to mX do
            if Prvky[i][j,k] then  write( 'X' )
                             else  write( '.' )
      end
   end;

end;

procedure TiskVzor;
var  i,j: byte;
begin
   TextColor( 10 );
   for i:=1 to mY do
   begin
      gotoXY( 70,  6+i );
      for j:=1 to mX do
         if Vzor[j,i] then  write( 'X' )
                      else  write( '.' );
   end
end;

{---------------------------------------------------------}
procedure Ohodnot;
var  s: integer;
     i,j,k: byte;
begin

   for k:=1 to PocetPrvku do
   begin
      s:=0;

      for i:=1 to mX do
      for j:=1 to mY do
         if Prvky[k] [i,j] = Vzor[i,j] then Inc(s)
                                       else Dec(s);

      Hodnota[k] := s
   end
end;
{---------------------------------------------------------}

procedure Nejlepsi;
{ nastavi MAX1, MAX2, MIN }
var  i: byte;
begin
   MAX1 := 1;
   MAX2 := 2;
   MIN  := 1;

   for i:=2 to PocetPrvku do
   if Hodnota[i] > Hodnota[ MAX1 ] then
             begin
                MAX2 := MAX1;
                MAX1 := i
             end
                                   else
   if Hodnota[i] > Hodnota[ MAX2 ] then
             begin
                MAX2 := i
             end
                                   else
   if Hodnota[i] < Hodnota[ MIN ] then
             begin
                MIN := i
             end
end;

procedure Potomek( r1,r2,  d: integer );
var  i,j: byte;
begin
   for i:=1 to mX do
   for j:=1 to mY do
   begin
      { podle rodicu: }
      if random < 0.5 then  Prvky[d] [i,j] := Prvky[ r1 ] [i,j]
                      else  Prvky[d] [i,j] := Prvky[ r2 ] [i,j];

      { mutace: }
      if random < cMutace then
         Prvky[d] [i,j] := not Prvky[d] [i,j]
   end
end;



begin
   InitPrvky;
   InitVzor;

   MAX1 := 255; MAX2 := 255; MIN := 255;
   TiskPrvky;
   TiskVzor;
   readln;

   repeat
      Ohodnot;
      Nejlepsi;
      TiskPrvky;
      TiskVzor;

      Potomek( MAX1, MAX2,  MIN );
{      MAX1 := 255; MAX2 := 255; MIN := 255; }
   until ReadKey=#27
end.
